

:-op(1200,xfx,'::=').
:- dynamic (::=)/2.
:- discontiguous (::=)/2.

terminal(naturalNumber).

%type ::= description.


axiom ::= enumeratedClass( c, { annotation }, 
                    [+deprecated], {i}, {classComparison}  ).
classComparison ::= sameClassAs(description).
classComparison ::= disjointWith(description).
classComparison ::= subClassOf(description).

restrictionComparison ::= classComparison .

%description ::= c.
%description ::= restriction.
description ::= unionOf( {description}, {classComparison} ).
description ::= intersectionOf( {description}, {classComparison} ).
description ::= complementOf( description, {classComparison} ).
description ::= oneOf( { i }, { classComparison } ).


restriction ::= restriction( cdp, value(dataLiteral), {restrictionComparison} ).
restriction ::= restriction( cop, value( i ), {restrictionComparison} ).
restriction ::= restriction( tp, value( i ), {restrictionComparison} ).

smallInt ::= naturalNumber .

comment(note,
   ['These rules broadens the scope of restrictions, domain and range conditions.'] ).
classInRestriction ::= description .

dataRange ::= oneOf( {dataLiteral} ).
comment(rationale,
  ['Using the same dataRange in multiple range constraints
    of restrictions requires too much repetition without 
    allowing ',link(dr),'.']).
axiom ::= dataRange( dr, {annotation}, {dataLiteral} ).
comment(rationale,
  ['A datarange declaraion which does not identify the individuals is not useful,
    except perhaps to document the intended range of a datatype property.
    However, it does make the proofs easier, and the special cases fewer.'] ).
axiom ::= dataRange( dr, +declaration, {annotation} ).