
cat(File) :-
   concat_atom(['doc-frags/',File,'.html'],FF),
   see(FF),
   repeat,
     get0(X),
     (X= -1;put(X),fail),
   !,
   seen.

% out(+ListOfFileBits,+ListOfCommands)
out(File,Commands) :-
   append(File,['.html'],Filex),
   concat_atom(['out/'|Filex],FF),
   wuser(['Creating ',FF,nl]),
   tell(FF),told,  % force close
   tell(FF),
   member(C,Commands),
   C,
   fail;
   told.


out(Lvl) :-
   out([Lvl,'-',syntax],
   [
     cat(header),
     title(2,[Lvl,' Abstract Syntax']),
     cat('syntax-intro'),
     htmlSyntax(Lvl),
     cat(trailer) ] ),
   out([Lvl,'-',mapping],
   [
     cat(header),
     title(2,[Lvl,' Mapping Rules']),
     cat('mapping-intro'),
     map(Lvl),
     cat(trailer) ] ),
   out([Lvl,'-',triples],
   [
     cat(header),
     title(2,[Lvl,' as RDF Graphs']),
     startDefinition(Lvl),
     cat(definition1),
     urirefCategories(Lvl),
     cat(definition2),
     blankCategories(Lvl),
     cat(definition3),
     tableList(Lvl),
     cat(definition4),
     triples(Lvl),
     blanks(Lvl),
     cat(trailer) ] ).

out :-
  out(lite),
  out(dl),
  out([intro],[
    cat(header),
    cat(intro),
    cat(trailer)]),
  out([diffs],[
    cat(header),
    cat(diffs),
    cat(trailer)]).

title(N,L) :-
  concat_atom(L,Title),
  name(Title,TName),
  maplist(space2dash,TName,AName),
  name(Anchor,AName),
  wlist(['<h',N,'> <a id="',Anchor,'" name="',Anchor,'">',nl,
         Title,'</h',N,'>']).


space2dash(32,45) :- !.
space2dash(X,X).

startDefinition(Lvl) :-
  wlist(['<p><a name="dfn-owl-',Lvl,'-rdf-graph" id="dfn-owl-',Lvl,'-rdf-graph">',nl
         ,'An OWL Full document  <span class="todo">[Add definition and link]</span> 
          is an OWL ',Lvl,' Ontology if and only if the
          <a href="http://www.w3.org/TR/owl-semantics/rdfs.html#RDF_graph_imports_closure">imports closure</a> of the
         RDF graph meets the following       conditions:</p>']).

urirefCategories(Lvl) :-
   uriref(_,C,_,_),
   C \= metaProperty,
   call(((Lvl=dl;C\=dataRange),!)),
   wlist(['<li>',C,'ID</li>',nl]),
   fail;
   true.


